/// ActiveColumnSwitch.js
// http://tc-image.3dn.ru/forum/9-251-835-16-1332918722
// http://akelpad.sourceforge.net/forum/viewtopic.php?p=5727#5727 
// Version: 1.5
// Author: Shengalts Aleksander aka Instructor
// 
//// Active column show/hide. 
// 
// Description(1033): Active column show/hide.
// Description(1049): /  .
// 
// Arguments:
// -Local=true     -Change active column visibilty locally (not saved after program restart). Default is false.
//
/// /  .
//
//  :
//    Toolbar/ContextMenu :
//
// -" " Call("Scripts::Main", 1, "ActiveColumnSwitch.js"`) Icon(0)
// -"  " Call("Scripts::Main", 1, "ActiveColumnSwitch.js", `-Local=true`)

// Usage global (item to Toolbar/ContextMenu plugin):
//    SET(128, If("SendMain(1223 /*AKD_GETFRAMEINFO*/, 69 /*FI_CARETOPTIONS*/, 0) & 0x2 /*CO_CARETVERTLINE*/", 0x1, 0x0))
//      "Active column (global)" Call("Scripts::Main", 2, "ActiveColumnSwitch.js")
//    UNSET(128)
//
// Usage local (item to Toolbar/ContextMenu plugin):
//    SET(128, If("SendEdit(3228 /*AEM_GETOPTIONS*/, 0, 0) & 0x400 /*AECO_ACTIVECOLUMN*/", 0x1, 0x0))
//      "Active column (local)" Call("Scripts::Main", 2, "ActiveColumnSwitch.js", `-Local=true`)
//    UNSET(128)

//Arguments
var bLocal=AkelPad.GetArgValue("Local", false);

//Variables
var hMainWnd=AkelPad.GetMainWnd();
var hWndEdit=AkelPad.GetEditWnd();
var oSys=AkelPad.SystemFunction();
var dwOptions;

if (hWndEdit)
{
  if (bLocal)
  {
    dwOptions=AkelPad.SendMessage(hWndEdit, 3227 /*AEM_GETOPTIONS*/, 0, 0);
    if (dwOptions & 0x400 /*AECO_ACTIVECOLUMN*/)
      AkelPad.SendMessage(hWndEdit, 3228 /*AEM_SETOPTIONS*/, 4 /*AECOOP_XOR*/, 0x400 /*AECO_ACTIVECOLUMN*/);
    else
      AkelPad.SendMessage(hWndEdit, 3228 /*AEM_SETOPTIONS*/, 2 /*AECOOP_OR*/, 0x400 /*AECO_ACTIVECOLUMN*/);
  }
  else
  {
    dwOptions=AkelPad.SendMessage(hMainWnd, 1223 /*AKD_GETFRAMEINFO*/, 69 /*FI_CARETOPTIONS*/, 0);
    if (dwOptions & 0x2 /*CO_CARETVERTLINE*/)
      dwOptions&=~0x2 /*CO_CARETVERTLINE*/;
    else
      dwOptions|=0x2 /*CO_CARETVERTLINE*/;
    AkelPad.SetFrameInfo(0, 17 /*FIS_CARETOPTIONS*/, dwOptions);
  }
}
