/// HexSelAs.js
/// http://tc-image.3dn.ru/forum/9-1006-14480-16-1453488083
//     HexSel
//  ============================================================================
//  Version: 2015-05-13
//  Author: Kley
//
//  *** GUI for HexSel plugin. ***
//
//  Note:
//  " "   HexSel.
//
//  Usage:
//  Call("Scripts::Main", 1, "HexSelAs.js")
//  ============================================================================
//Options
var nDirection =     0;
var nRadix     =     0;
var nUnicode   =  1200;
var nAnsi      =     8;
var nSelect    =     0;
var aPrefix    = ["<"];
var aSuffix    = [">"];
var aCurfix    =    [];

//Variables
var hMainWnd = AkelPad.GetMainWnd();
var oSys = AkelPad.SystemFunction();
var hInstanceDLL = AkelPad.GetInstanceDll();
var pClassName = "AkelPad::Scripts::" + WScript.ScriptName + "::" + oSys.Call("kernel32::GetCurrentProcessId");
var hWndDialog;
var hWndControl;
var hWndDrctAuto;
var hWndHex2Text;
var hWndText2Hex;
var hWndCboPrefix;
var hWndCboSuffix;
var hWndRadixHex;
var hWndRadixDec;
var hWndRadixOct;
var hWndUtf16LE;
var hWndUtf16BE;
var hWndChkSelect;
var hWndChkAnsi;
var hWndReplace;
var hWndCansel;
var ptScale = [];
var hGuiFont;
var hFocus;

//Control IDs
var ID_OPT_AUTO    = 1001;
var ID_OPT_STR2HEX = 1002;
var ID_OPT_HEX2STR = 1003;
var ID_CBO_PREFIX  = 1004;
var ID_CBO_SUFFIX  = 1005;
var ID_OPT_HEX     = 1006;
var ID_OPT_DEC     = 1007;
var ID_OPT_OCT     = 1008;
var ID_OPT_LE      = 1009;
var ID_OPT_BE      = 1010;
var ID_CHK_SELECT  = 1011;
var ID_CHK_ANSI    = 1012;
var ID_REPLACE     = 1013;
var ID_CANCEL      = 1014;
var ID_LABEL       =   -1;

GetLangStrings();
ReadIni();

if (AkelPad.GetEditWnd()) {

  if (AkelPad.WindowRegisterClass(pClassName)) {

    var sizeNonClient = [];

    sizeNonClient.cx = oSys.Call("user32::GetSystemMetrics", 7 /*SM_CXFIXEDFRAME*/) * 2;
    sizeNonClient.cy = oSys.Call("user32::GetSystemMetrics", 8 /*SM_CYFIXEDFRAME*/) * 2 +
                       oSys.Call("user32::GetSystemMetrics", 4 /*SM_CYCAPTION*/);

    //Get scale factor for ScaleX and ScaleY
    ScaleInit(0, hMainWnd);

    //Create dialog
    hWndDialog = oSys.Call("user32::CreateWindowEx" + _TCHAR,
                           0,                              //dwExStyle
                           pClassName,                     //lpClassName
                           0,                              //lpWindowName
                           0x90CA0000,                     //WS_VISIBLE|WS_POPUP|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX
                           ScaleX(0),                      //x
                           ScaleY(0),                      //y
                           ScaleX(450) + sizeNonClient.cx, //nWidth
                           ScaleY(240) + sizeNonClient.cy, //nHeight
                           hMainWnd,                       //hWndParent
                           0,                              //ID
                           hInstanceDLL,                   //hInstance
                           DialogCallback);                //Script function callback.
                                                           //To use it class must be registered by WindowRegisterClass.
    if (hWndDialog) {

      //Allow other scripts running
      AkelPad.ScriptNoMutex();
      //Message loop
      AkelPad.WindowGetMessage();
    }
    AkelPad.WindowUnregisterClass(pClassName);
  }
  else if (hWndDialog = oSys.Call("user32::FindWindowEx" + _TCHAR, 0, 0, pClassName, 0)) {

    if (oSys.Call("user32::IsIconic", hWndDialog))
      oSys.Call("user32::ShowWindow", hWndDialog, 9 /*SW_RESTORE*/);

    AkelPad.SendMessage(hWndDialog, 7 /*WM_SETFOCUS*/, 0, 0);
  }
}

function DialogCallback(hWnd, uMsg, wParam, lParam) {

  if (uMsg == 1) {  //WM_CREATE

    hGuiFont = oSys.Call("gdi32::GetStockObject", 17 /*DEFAULT_GUI_FONT*/);

    //Dialog caption
    SetWindowText(hWnd, WScript.ScriptBaseName);


    ////GroupBox DIRECTION

    //Create window
    hWndControl=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000007,     //WS_VISIBLE|WS_CHILD|BS_GROUPBOX
                            ScaleX(10),     //x
                            ScaleY(14),     //y
                            ScaleX(155),    //nWidth
                            ScaleY(90),     //nHeight
                            hWnd,           //hWndParent
                            ID_LABEL,       //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndControl, hGuiFont, STR_DIRECT);


    ////RadioButton AUTO

    //Create window
    hWndDrctAuto=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000009,     //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            ScaleX(20),     //x
                            ScaleY(35),     //y
                            ScaleX(130),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_OPT_AUTO,    //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndDrctAuto, hGuiFont, STR_AUTO);


    ////RadioButton TEXT2HEX

    //Create window
    hWndText2Hex=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000009,     //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            ScaleX(20),     //x
                            ScaleY(55),     //y
                            ScaleX(130),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_OPT_STR2HEX, //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndText2Hex, hGuiFont, STR_STR2HEX);


    ////RadioButton HEX2TEXT

    //Create window
    hWndHex2Text=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000009,     //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            ScaleX(20),     //x
                            ScaleY(75),     //y
                            ScaleX(130),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_OPT_HEX2STR, //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndHex2Text, hGuiFont, STR_HEX2STR);


    ////GroupBox SEPARATOR

    //Create window
    hWndControl=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000007,     //WS_VISIBLE|WS_CHILD|BS_GROUPBOX
                            ScaleX(10),     //x
                            ScaleY(108),    //y
                            ScaleX(155),    //nWidth
                            ScaleY(90),     //nHeight
                            hWnd,           //hWndParent
                            ID_LABEL,       //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndControl, hGuiFont, STR_SEP);


    ////Static PREFIX

    //Create window
    hWndControl = oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "STATIC",       //lpClassName
                            0,              //lpWindowName
                            0x50000000,     //0x50000000|0x0002,   //WS_VISIBLE|WS_CHILD
                            ScaleX(20),     //x
                            ScaleY(132),    //y
                            ScaleX(58),     //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_LABEL,       //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndControl, hGuiFont, STR_PREFIX);


    ////Static SUFFIX

    //Create window
    hWndControl = oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "STATIC",       //lpClassName
                            0,              //lpWindowName
                            0x50000000,     //0x50000000|0x0002,   //WS_VISIBLE|WS_CHILD
                            ScaleX(20),     //x
                            ScaleY(159),    //y
                            ScaleX(58),     //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_LABEL,       //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndControl, hGuiFont, STR_SUFFIX);


    ////ComboBox PREFIX

    //Create window
    hWndCboPrefix=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "COMBOBOX",     //lpClassName
                            0,              //lpWindowName
                            0x50210042,     //WS_VISIBLE|WS_CHILD|WS_TABSTOP|WS_VSCROLL|CBS_DROPDOWN|CBS_AUTOHSCROLL
                            ScaleX(82),     //x
                            ScaleY(132),    //y
                            ScaleX(70),     //nWidth
                            ScaleY(160),    //nHeight
                            hWnd,           //hWndParent
                            ID_CBO_PREFIX,  //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Fill combobox
    FillCBPrefix();

    //Set font and text
    SetWindowFontAndText(hWndCboPrefix, hGuiFont, aCurfix[0]);


    ////ComboBox SUFFIX

    //Create window
    hWndCboSuffix=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "COMBOBOX",     //lpClassName
                            0,              //lpWindowName
                            0x50210042,     //WS_VISIBLE|WS_CHILD|WS_TABSTOP|WS_VSCROLL|CBS_DROPDOWN|CBS_AUTOHSCROLL
                            ScaleX(82),     //x
                            ScaleY(159),    //y
                            ScaleX(70),     //nWidth
                            ScaleY(160),    //nHeight
                            hWnd,           //hWndParent
                            ID_CBO_SUFFIX,  //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Fill combobox
    FillCBSuffix();

    //Set font and text
    SetWindowFontAndText(hWndCboSuffix, hGuiFont, aCurfix[1]);


    ////GroupBox RADIX

    //Create window
    hWndControl=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000007,     //WS_VISIBLE|WS_CHILD|BS_GROUPBOX
                            ScaleX(185),    //x
                            ScaleY(14),     //y
                            ScaleX(155),    //nWidth
                            ScaleY(90),     //nHeight
                            hWnd,           //hWndParent
                            ID_LABEL,       //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndControl, hGuiFont, STR_RADIX);


    ////RadioButton HEX

    //Create window
    hWndRadixHex=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000009,     //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            ScaleX(195),    //x
                            ScaleY(35),     //y
                            ScaleX(130),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_OPT_HEX,     //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndRadixHex, hGuiFont, STR_HEX);


    ////RadioButton DEC

    //Create window
    hWndRadixDec=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000009,     //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            ScaleX(195),    //x
                            ScaleY(55),     //y
                            ScaleX(130),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_OPT_DEC,     //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndRadixDec, hGuiFont, STR_DEC);


    ////RadioButton OCT

    //Create window
    hWndRadixOct=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000009,     //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            ScaleX(195),    //x
                            ScaleY(75),     //y
                            ScaleX(130),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_OPT_OCT,     //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndRadixOct, hGuiFont, STR_OCT);


    ////GroupBox UTF 16

    //Create window
    hWndControl=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000007,     //WS_VISIBLE|WS_CHILD|BS_GROUPBOX
                            ScaleX(185),    //x
                            ScaleY(108),    //y
                            ScaleX(155),    //nWidth
                            ScaleY(90),     //nHeight
                            hWnd,           //hWndParent
                            ID_LABEL,       //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndControl, hGuiFont, STR_UTF16);


    ////RadioButton 1200 LE

    //Create window
    hWndUtf16LE=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000009,     //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            ScaleX(195),    //x
                            ScaleY(134),    //y
                            ScaleX(130),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_OPT_LE,      //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndUtf16LE, hGuiFont, "1200 (UTF-16 LE)");


    ////RadioButton 1201 BE

    //Create window
    hWndUtf16BE=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50000009,     //WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON
                            ScaleX(195),    //x
                            ScaleY(161),    //y
                            ScaleX(130),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_OPT_BE,      //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndUtf16BE, hGuiFont, "1201 (UTF-16 BE)");


    ////CheckBox SELECT

    //Create window
    hWndChkSelect=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50010003,     //WS_VISIBLE|WS_CHILD|WS_TABSTOP|BS_AUTOCHECKBOX
                            ScaleX(10),     //x
                            ScaleY(206),    //y
                            ScaleX(160),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_CHK_SELECT,  //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndChkSelect, hGuiFont, STR_SELECT);


    ////CheckBox ANSI

    //Create window
    hWndChkAnsi=oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50010003,     //WS_VISIBLE|WS_CHILD|WS_TABSTOP|BS_AUTOCHECKBOX
                            ScaleX(195),    //x
                            ScaleY(206),    //y
                            ScaleX(130),    //nWidth
                            ScaleY(16),     //nHeight
                            hWnd,           //hWndParent
                            ID_CHK_ANSI,    //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndChkAnsi, hGuiFont, STR_ANSI);


    ////Button REPLACE

    //Create window
    hWndReplace = oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50010000,     //0x50010001: WS_VISIBLE|WS_CHILD|WS_TABSTOP|BS_DEFPUSHBUTTON(0x0001)
                            ScaleX(360),    //x
                            ScaleY(175),    //y
                            ScaleX(75),     //nWidth
                            ScaleY(23),     //nHeight
                            hWnd,           //hWndParent
                            ID_REPLACE,     //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndReplace, hGuiFont, STR_CHANGE);


    ////Button CANCEL

    //Create window
    hWndCansel = oSys.Call("user32::CreateWindowEx" + _TCHAR,
                            0,              //dwExStyle
                            "BUTTON",       //lpClassName
                            0,              //lpWindowName
                            0x50010000,     //0x50010001: WS_VISIBLE|WS_CHILD|WS_TABSTOP|BS_DEFPUSHBUTTON(0x0001)
                            ScaleX(360),    //x
                            ScaleY(204),    //y
                            ScaleX(75),     //nWidth
                            ScaleY(23),     //nHeight
                            hWnd,           //hWndParent
                            ID_CANCEL,      //ID
                            hInstanceDLL,   //hInstance
                            0);             //lpParam
    //Set font and text
    SetWindowFontAndText(hWndCansel, hGuiFont, STR_CANCEL);

    //Center dialog
    CenterWindow(hMainWnd, hWnd);

    SetButtonState();
  }

  else if ((uMsg == 6 /*WM_ACTIVATE*/) && (! wParam))
    hFocus = oSys.Call("User32::GetFocus");

  else if (uMsg == 7) { //WM_SETFOCUS

    if (! hFocus)
      oSys.Call("User32::SetFocus", hWndCboPrefix);
    else oSys.Call("User32::SetFocus", hFocus);
  }

  else if (uMsg == 256) { //WM_KEYDOWN

    if (wParam == 13 /*VK_RETURN*/)
      oSys.Call("user32::PostMessage" + _TCHAR, hWndDialog, 273 /*WM_COMMAND*/, ID_REPLACE, 0);

    if (wParam == 27 /*VK_ESCAPE*/)
      oSys.Call("user32::PostMessage" + _TCHAR, hWndDialog, 273 /*WM_COMMAND*/, ID_CANCEL, 0);
  }

  else if (uMsg == 273) { //WM_COMMAND

    var nID = wParam & 0xffff;

    if ( nID == ID_OPT_AUTO || nID == ID_OPT_HEX2STR || nID == ID_OPT_STR2HEX ||
         nID == ID_OPT_HEX  || nID == ID_OPT_DEC     || nID == ID_OPT_OCT     ||
         nID == ID_OPT_LE   || nID == ID_OPT_BE      || nID == ID_CHK_ANSI    ||
         nID == ID_CHK_SELECT ) {

      SetButtonState(nID);
    }

    else if (nID == ID_REPLACE)
      APTextChange();

    else if (nID == ID_CANCEL)
      oSys.Call("user32::PostMessage" + _TCHAR, hWndDialog, 16 /*WM_CLOSE*/, 0, 0);
  }

  else if (uMsg == 16) { //WM_CLOSE

    WriteIni();

    //Destroy dialog
    oSys.Call("user32::DestroyWindow", hWnd);
  }

  else if (uMsg == 2)  //WM_DESTROY
    //Exit message loop
    oSys.Call("user32::PostQuitMessage", 0);

  return 0;
}

function ScaleInit(hDC, hWnd) {

  if (!ptScale.x && !ptScale.y) {

    var hNewDC = hDC;

    if (!hDC)
      hNewDC = oSys.Call("user32::GetDC", hWnd);

    if (hNewDC) {

      ptScale.x = oSys.Call("gdi32::GetDeviceCaps", hNewDC, 88 /*LOGPIXELSX*/);
      ptScale.y = oSys.Call("gdi32::GetDeviceCaps", hNewDC, 90 /*LOGPIXELSY*/);

      //Align to 16 pixel
      if (ptScale.x % 16) ptScale.x+=16 - ptScale.x % 16;
      if (ptScale.y % 16) ptScale.y+=16 - ptScale.y % 16;
    }
    else return false;

    if (!hDC)
      oSys.Call("user32::ReleaseDC", hWnd, hNewDC);
  }
  return true;
}

function ScaleX(x) {

  if (ptScale.x)
    return oSys.Call("kernel32::MulDiv", x, ptScale.x, 96);
  return x;
}

function ScaleY(y) {

  if (ptScale.y)
    return oSys.Call("kernel32::MulDiv", y, ptScale.y, 96);
  return y;
}

function SetWindowFontAndText(hWnd, hFont, pText) {

  AkelPad.SendMessage(hWnd, 48 /*WM_SETFONT*/, hFont, 1);
  SetWindowText(hWnd, pText);
}

function SetWindowText(hWnd, sText) {

  oSys.Call("User32::SetWindowText" + _TCHAR, hWnd, sText);
}

function CenterWindow(hWndParent, hWnd) {

  var lpRect;
  var rcWndParent = [];
  var rcWnd = [];
  var X;
  var Y;

  if (lpRect = AkelPad.MemAlloc(16)) {  //sizeof(RECT)

    if (!hWndParent)
      hWndParent = oSys.Call("user32::GetDesktopWindow");

    oSys.Call("user32::GetWindowRect", hWndParent, lpRect);
    RectToArray(lpRect, rcWndParent);

    oSys.Call("user32::GetWindowRect", hWnd, lpRect);
    RectToArray(lpRect, rcWnd);

    //Center window
    X = rcWndParent.left + ((rcWndParent.right - rcWndParent.left) / 2 - (rcWnd.right - rcWnd.left) / 2);
    Y = rcWndParent.top + ((rcWndParent.bottom - rcWndParent.top) / 2 - (rcWnd.bottom - rcWnd.top) / 2);

    oSys.Call("user32::SetWindowPos", hWnd, 0, X, Y, 0, 0, 0x15 /*SWP_NOZORDER|SWP_NOACTIVATE|SWP_NOSIZE*/);

    AkelPad.MemFree(lpRect);
  }
}

function RectToArray(lpRect, rcRect) {

  rcRect.left   = AkelPad.MemRead(_PtrAdd(lpRect,  0) /*offsetof(RECT, left)*/  , 3 /*DT_DWORD*/);
  rcRect.top    = AkelPad.MemRead(_PtrAdd(lpRect,  4) /*offsetof(RECT, top)*/   , 3 /*DT_DWORD*/);
  rcRect.right  = AkelPad.MemRead(_PtrAdd(lpRect,  8) /*offsetof(RECT, right)*/ , 3 /*DT_DWORD*/);
  rcRect.bottom = AkelPad.MemRead(_PtrAdd(lpRect, 12) /*offsetof(RECT, bottom)*/, 3 /*DT_DWORD*/);
  return rcRect;
}

function FillCBPrefix() {

  for (var i = 0; i < aPrefix.length; ++i)
    AkelPad.SendMessage(hWndCboPrefix, 323 /*CB_ADDSTRING*/, 0, aPrefix[i]);

  AkelPad.SendMessage(hWndCboPrefix, 334 /*CB_SETCURSEL*/, 0, 0);
}

function FillCBSuffix() {

  for (var i = 0; i < aSuffix.length; ++i)
    AkelPad.SendMessage(hWndCboSuffix, 323 /*CB_ADDSTRING*/, 0, aSuffix[i]);

  AkelPad.SendMessage(hWndCboSuffix, 334 /*CB_SETCURSEL*/, 0, 0);
}

function SetButtonState(nIDC) {

  switch (nIDC) {

    case ID_OPT_AUTO:    nDirection =    0; break;
    case ID_OPT_STR2HEX: nDirection =    1; break;
    case ID_OPT_HEX2STR: nDirection =    2; break;
    case ID_OPT_HEX:     nRadix     =    0; break;
    case ID_OPT_DEC:     nRadix     =  256; break;
    case ID_OPT_OCT:     nRadix     =  512; break;
    case ID_OPT_LE:      nUnicode   = 1200; break;
    case ID_OPT_BE:      nUnicode   = 1201; break;
    case ID_CHK_ANSI:
      nAnsi = (AkelPad.SendMessage(hWndChkAnsi, 240 /*BM_GETCHECK*/, 0, 0)) ? 4 : 8;
      break;
    case ID_CHK_SELECT:
      nSelect = (AkelPad.SendMessage(hWndChkSelect, 240 /*BM_GETCHECK*/, 0, 0)) ? 16 : 0;
      break;
  }

  AkelPad.SendMessage(hWndDrctAuto, 241 /*BM_SETCHECK*/, (nDirection == 0), 0);
  AkelPad.SendMessage(hWndHex2Text, 241 /*BM_SETCHECK*/, (nDirection == 2), 0);
  AkelPad.SendMessage(hWndText2Hex, 241 /*BM_SETCHECK*/, (nDirection == 1), 0);

  AkelPad.SendMessage(hWndRadixHex, 241 /*BM_SETCHECK*/, (nRadix ==   0), 0);
  AkelPad.SendMessage(hWndRadixDec, 241 /*BM_SETCHECK*/, (nRadix == 256), 0);
  AkelPad.SendMessage(hWndRadixOct, 241 /*BM_SETCHECK*/, (nRadix == 512), 0);

  AkelPad.SendMessage(hWndUtf16LE, 241 /*BM_SETCHECK*/, (nUnicode == 1200), 0);
  AkelPad.SendMessage(hWndUtf16BE, 241 /*BM_SETCHECK*/, (nUnicode == 1201), 0);

  oSys.Call("user32::EnableWindow", hWndUtf16LE, nAnsi == 8);
  oSys.Call("user32::EnableWindow", hWndUtf16BE, nAnsi == 8);

  AkelPad.SendMessage(hWndChkAnsi,   241 /*BM_SETCHECK*/, (nAnsi   ==  4), 0);
  AkelPad.SendMessage(hWndChkSelect, 241 /*BM_SETCHECK*/, (nSelect == 16), 0);
}

function ReadIni() {

  var oSet = AkelPad.ScriptSettings();

  if (oSet.Begin(WScript.ScriptBaseName, 0x01 /*POB_READ*/)) {

    //Read settings
    nDirection = oSet.Read("Direction", 1 /*PO_DWORD*/,      0);
    nRadix     = oSet.Read("Radix",     1 /*PO_DWORD*/,      0);
    nUnicode   = oSet.Read("Unicode",   1 /*PO_DWORD*/,   1200);
    nAnsi      = oSet.Read("Ansi",      1 /*PO_DWORD*/,      8);
    nSelect    = oSet.Read("Select",    1 /*PO_DWORD*/,      0);
    aPrefix    = oSet.Read("Prefix",    3 /*PO_STRING*/,   "<").split(",");
    aSuffix    = oSet.Read("Suffix",    3 /*PO_STRING*/,   ">").split(",");
    aCurfix    = oSet.Read("Curfix",    3 /*PO_STRING*/, "<,>").split(",");

    oSet.End();
  }
}

function WriteIni() {

  var bExist = false;
  var i;

  aCurfix[0] = GetWindowText(hWndCboPrefix).replace(/\\/g, "\\");
  aCurfix[1] = GetWindowText(hWndCboSuffix).replace(/\\/g, "\\");

  for (i = 0; i < aPrefix.length; i++) {

    if (aPrefix[i] == aCurfix[0]) {
      bExist = true;
      break;
    }
  }

  if (!bExist && aCurfix[0])
    aPrefix.push(aCurfix[0]);

  bExist = false;

  for (i = 0; i < aSuffix.length; i++) {

    if (aSuffix[i] == aCurfix[1]) {
      bExist = true;
      break;
    }
  }

  if (!bExist && aCurfix[1])
    aSuffix.push(aCurfix[1]);

  var oSet = AkelPad.ScriptSettings();

  if (oSet.Begin(WScript.ScriptBaseName, 0x2 /*POB_SAVE*/)) {

    //Save settings
    oSet.Write("Direction", 1 /*PO_DWORD*/,  nDirection);
    oSet.Write("Radix",     1 /*PO_DWORD*/,  nRadix);
    oSet.Write("Unicode",   1 /*PO_DWORD*/,  nUnicode);
    oSet.Write("Ansi",      1 /*PO_DWORD*/,  nAnsi);
    oSet.Write("Select",    1 /*PO_DWORD*/,  nSelect);
    oSet.Write("Prefix",    3 /*PO_STRING*/, aPrefix.join(","));
    oSet.Write("Suffix",    3 /*PO_STRING*/, aSuffix.join(","));
    oSet.Write("Curfix",    3 /*PO_STRING*/, aCurfix.join(","));

    oSet.End();
  }
}

function GetWindowText(hWnd) {

  var lpBuffer = AkelPad.MemAlloc(256 * _TSIZE);
  var sText;

  oSys.Call("User32::GetWindowText" + _TCHAR, hWnd, lpBuffer, 256);
  sText = AkelPad.MemRead(lpBuffer, _TSTR);
  AkelPad.MemFree(lpBuffer);
  return sText;
}

function APTextChange() {

  if (AkelPad.GetEditWnd()) {

    if (AkelPad.GetSelStart() != AkelPad.GetSelEnd())

      AkelPad.Call("HexSel::Main", 2, nDirection + nRadix + nAnsi + nSelect,
                                      GetWindowText(hWndCboPrefix),
                                      GetWindowText(hWndCboSuffix),
                                      -1,              //ANSICODEPAGE (Auto)
                                      nUnicode,        //UNICODECODEPAGE
                                      AkelPad.GetSelText());
  }
}

function GetLangStrings() {

  if (AkelPad.GetLangId(0 /*LANGID_FULL*/) == 1049 /*Russian*/) {

    STR_DIRECT  = "";
    STR_AUTO    = "";
    STR_STR2HEX = " -> Hex";
    STR_HEX2STR = "Hex -> ";
    STR_PREFIX  = ":";
    STR_SUFFIX  = ":";
    STR_SEP     = "";
    STR_RADIX   = " ";
    STR_HEX     = "";
    STR_DEC     = "";
    STR_OCT     = "";
    STR_SELECT  = "   ";
    STR_UTF16   = " ";
    STR_ANSI    = "   ()";
    STR_CHANGE  = "";
    STR_CANCEL  = "";
  }
  else {

    STR_DIRECT  = "Direction";
    STR_AUTO    = "Auto";
    STR_STR2HEX = "Text -> Hex";
    STR_HEX2STR = "Hex -> Text";
    STR_PREFIX  = "Prefix:";
    STR_SUFFIX  = "Suffix:";
    STR_SEP     = "Enclose";
    STR_RADIX   = "Radix";
    STR_HEX     = "Hexadecimal";
    STR_DEC     = "Decimal";
    STR_OCT     = "Octal";
    STR_SELECT  = " Select after replace";
    STR_UTF16   = "Double bytes";
    STR_ANSI    = " Single byte (auto)";
    STR_CHANGE  = "Replace";
    STR_CANCEL  = "Exit";
  }
}
