' ReplaceCoding.vbs
'========================   Описание   =====================================
' Различные исправления (замены) символов кодировки в выделенном тексте
' (если ничего не выделено преобразовывается весь текст)
'=======================   Параметры  ======================================
' 1 - символы DOS
' 2 - символы WIN
' 3 - символы KOI8-R
' 4 - диакритические символы
' 5 - подобные русские символы на латинские
' 6 - подобные латинские символы на русские
'=======================   Дополнение   ====================================
' Скрипт должен быть сохранён в кодировке UTF-8
'=========================    Пример    ====================================
' -"Заменить кракозябры DOS" Call("Scripts::Main", 1, "ReplaceCoding.vbs", `1`) Icon("%a\AkelPadImage.dll",95)
' -"Заменить кракозябры WIN" Call("Scripts::Main", 1, "ReplaceCoding.vbs", `2`) Icon("%a\AkelPadImage.dll",95)
' -"Заменить кракозябры KOI8-R" Call("Scripts::Main", 1, "ReplaceCoding.vbs", `3`) Icon("%a\AkelPadImage.dll",95)
' -"Заменить диакритические символы" Call("Scripts::Main", 1, "ReplaceCoding.vbs", `4`) Icon("%a\AkelPadImage.dll",24)
' -"Замена в выделенном Русских букв Английскими" Call("Scripts::Main", 1, "ReplaceCoding.vbs", `5`) Icon("%a\AkelPadImage.dll",371)
' -"Замена в выделенном Английских букв Русскими" Call("Scripts::Main", 1, "ReplaceCoding.vbs", `6`) Icon("%a\AkelPadImage.dll",372)

' Автор:           Аверин Андрей
' Версия:          1.2 (27.11.2013 - 12.01.2015)
' Mail:            Averin-And@yandex.ru
' Site:            http://tc-image.3dn.ru/forum/9-891-7825-16-1385577467
'===========================================================================
With AkelPad .Include("FunctionsSave.vbs") : Text = .GetSelText
  If Len(Text) = 0 Then 
    Text = .GetTextRange(0, -1) : .SetSel 0, -1
  End If
  If Len(Text) = 0 Then Wscript.Quit
  Cnt = WScript.Arguments(0)
  
  Select Case Cnt
    Case 1 ' DOS
      Source = Array("Ç", "ü", "é", "â", "ä", "à", "≡", "å", "ç", "ê", "ë", "è", "ï", "î", "ì", "Ä", "Å", "É", "æ", "Æ", "ô", "ö", "ò", "û", "ù", "ÿ", "Ö", "Ü", "¢", "£", "¥", "₧", "ƒ", "á", "í", "ó", "ú", "ñ", "Ñ", "±", "ª", "º", "¿", "⌐", "¬", "½", "¼", "¡", "«", "»", "α", "ß", "Γ", "π", "Σ", "σ", "µ", "τ", "Φ", "Θ", "Ω", "δ", "∞", "φ", "ε", "∩")
    Case 2 ' WIN
       Source =  Array("À", "Á", "Â", "Ã", "Ä", "Å", "¨", "Æ", "Ç", "È", "É", "Ê", "Ë", "Ì", "Í", "Î", "Ï", "Ð", "Ñ", "Ò", "Ó", "Ô", "Õ", "Ö", "×", "Ø", "Ù", "Ú", "Û", "Ü", "Ý", "Þ", "ß", "à", "á", "â", "ã", "ä", "å", "¸", "æ", "ç", "è", "é", "ê", "ë", "ì", "í", "î", "ï", "ð", "ñ", "ò", "ó", "ô", "õ", "ö", "÷", "ø", "ù", "ú", "û", "ü", "ý", "þ", "ÿ")
    Case 3 ' KOI8-R
      Source = Array("ю", "а", "б", "ц", "д", "е", "╗", "ф", "г", "х", "и", "й", "к", "л", "м", "н", "о", "п", "я", "р", "с", "т", "у", "ж", "в", "ь", "ы", "з", "ш", "э", "щ", "ч", "ъ", "Ю", "А", "Б", "Ц", "Д", "Е", "╦", "Ф", "Г", "Х", "И", "Й", "К", "Л", "М", "Н", "О", "П", "Я", "Р", "С", "Т", "У", "Ж", "В", "Ь", "Ы", "З", "Ш", "Э", "Щ", "Ч", "Ъ")
    Case 4 ' Диакритичные символы
      Source = Array("à", "À", "á", "Á", "â", "Â", "ã", "Ã", "ä", "Ä", "å", "Å", "æ", "Æ", "ç", "Ç", "È", "è", "é", "É", "ê", "Ê", "ë", "Ë", "Ì", "ì", "í", "Í", "î", "Î", "Ï", "ï", "Ð", "ð", "ñ", "Ñ", "Ò", "ò", "Ó", "Ó", "ó", "ó", "ô", "Ô", "Õ", "õ", "ö", "Ö", "ù", "Ù", "Ú", "ú", "û", "Û", "ü", "Ü", "ý", "Ý", "ÿ", "Ÿ", "ā", "Ā", "ă", "Ă", "Ą", "Ą", "ą", "ą", "Ć", "ć", "Ć", "ć", "ĉ", "Ĉ", "Ċ", "ċ", "č", "Č", "ď", "Ď", "Đ", "đ", "Ē", "ē", "ĕ", "Ĕ", "ė", "Ė", "ę", "Ę", "Ę", "ę", "Ě", "ě", "ĝ", "Ĝ", "ğ", "Ğ", "ġ", "Ġ", "ģ", "Ģ", "Ĥ", "ĥ", "ħ", "Ħ", "ĩ", "Ĩ", "ī", "Ī", "Ĭ", "ĭ", "Į", "į", "İ", "ı", "ĳ", "Ĳ", "ĵ", "Ĵ", "ķ", "Ķ", "ĸ", "ĺ", "Ĺ", "Ļ", "ļ", "Ľ", "ľ", "Ŀ", "ŀ", "Ł", "ł", "Ł", "ł", "ń", "Ń", "ń", "Ń", "ņ", "Ņ", "ň", "Ň", "ŉ", "Ō", "ō", "Ŏ", "ŏ", "ő", "Ő", "œ", "Œ", "Ŕ", "ŕ", "ŗ", "Ŗ", "ř", "Ř", "Ś", "ś", "ś", "Ś", "ŝ", "Ŝ", "ş", "Ş", "š", "Š", "Ţ", "ţ", "ť", "Ť", "ŧ", "Ŧ", "ũ", "Ũ", "Ū", "ū", "ŭ", "Ŭ", "ů", "Ů", "Ű", "ű", "Ų", "ų", "ŵ", "Ŵ", "ŷ", "Ŷ", "Ź", "Ź", "ź", "ź", "ż", "Ż", "Ż", "ż", "ž", "Ž", "ƀ", "ƈ", "Ƈ", "ƒ", "Ƒ", "Ƙ", "ƙ", "ơ", "Ơ", "ƥ", "Ƥ", "ƫ", "ƭ", "Ƭ", "Ư", "ư", "Ƶ", "ƶ", "Ǆ", "ǅ", "ǆ", "ǈ", "Ǉ", "ǉ", "ǋ", "ǌ", "Ǌ", "ǎ", "Ǎ", "ǐ", "Ǐ", "Ǒ", "ǒ", "Ǔ", "ǔ", "ǖ", "Ǖ", "ǘ", "Ǘ", "Ǚ", "ǚ", "Ǜ", "ǜ", "ǝ", "ǟ", "Ǟ", "ǡ", "Ǡ", "ǣ", "Ǣ", "ǥ", "Ǥ", "ǧ", "Ǧ", "ǩ", "Ǩ", "ǫ", "Ǫ", "ǭ", "Ǭ", "Ǯ", "ǰ", "ǯ", "Ǳ", "ǲ", "ǳ", "Ǵ", "ǵ", "Ǻ", "ǻ", "Ǽ", "ǽ", "Ǿ", "ǿ", "Ȁ", "ȁ", "Ȃ", "ȃ", "Ȅ", "ȅ", "Ȇ", "ȇ", "ȉ", "Ȉ", "Ȋ", "ȋ", "Ȍ", "ȍ", "ȏ", "Ȏ", "Ȑ", "ȑ", "Ȓ", "ȓ", "ȕ", "Ȕ", "ȗ", "Ȗ", "ɐ", "ɑ", "ɒ", "Ɓ", "Ɖ", "ɖ", "Ɗ", "ɗ", "ɛ", "Ɠ", "Ʀ", "Ʈ", "ʤ", "ʣ", "ʥ", "ʦ", "ʧ", "ΐ", "Ά", "Έ", "Ή", "Ί", "ϊ", "ϋ", "Ό", "ό", "ύ", "Ύ", "і", "ї", "ј", "ќ", "ў", "ӑ", "Ӑ", "Ӓ", "ӓ", "ӕ", "Ӕ", "Ӗ", "ӗ")
      Target = Array("a","A","a","A","a","A","a","A","a","A","a","A","ae","AE","c","C","E","e","e","E","e","E","e","E","I","i","i","I","i","I","I","i","D","d","n","N","O","o","O","O","o","o","o","O","O","o","o","O","u","U","U","u","u","U","u","U","y","Y","y","Y","a","A","a","A","A","A","a","a","C","c","C","c","c","C","C","c","c","C","d","D","D","d","E","e","e","E","e","E","e","E","E","e","E","e","g","G","g","G","g","G","g","G","H","h","h","H","i","I","i","I","I","i","I","i","I","i","ij","IJ","j","J","k","K","k","l","L","L","l","L","l","L","l","L","l","L","l","n","N","n","N","n","N","n","N","n","O","o","O","o","o","O","oe","OE","R","r","r","R","r","R","S","s","s","S","s","S","s","S","s","S","T","t","t","T","t","T","u","U","U","u","u","U","u","U","U","u","U","u","w","W","Y","Y","Z","Z","z","z","z","Z","Z","z","z","Z","b","c","C","f","F","K","k","o","O","p","P","t","t","T","U","u","Z","z","DZ","Dz","dz","Lj","LJ","lj","Nj","nj","NJ","a","A","i","I","O","o","U","u","u","U","u","U","U","u","U","u","e","a","A","a","A","ae","AE","g","G","g","G","k","K","o","O","o","O","Z","J","z","DZ","Dz","dz","G","g","A","a","AE","ae","O","o","A","a","A","a","E","e","E","e","i","I","I","i","O","o","o","O","R","r","R","r","u","U","u","U","a","a","a","B","D","d","D","d","e","G","R","T","dz","dz","dz","ts","tf","i","A","E","H","I","i","u","O","o","u","Y","i","i","j","k","y","a","A","A","a","ae","AE","E","e")
    Case 5, 6 ' 
      Source = Array("с", "е", "а", "о", "у", "х", "р", "С", "Е", "А", "О", "Т", "В", "Х", "Н", "К", "М", "Р", "р")
      Target = Array("c", "e", "a", "o", "y", "x", "́р", "C", "E", "A", "O", "T", "B", "X", "H", "K", "M", "P", "p")
  End Select
  Select Case Cnt
    Case 1, 2, 3
      Target = Split("А;Б;В;Г;Д;Е;Ё;Ж;З;И;Й;К;Л;М;Н;О;П;Р;С;Т;У;Ф;Х;Ц;Ч;Ш;Щ;Ъ;Ы;Ь;Э;Ю;Я;а;б;в;г;д;е;ё;ж;з;и;й;к;л;м;н;о;п;р;с;т;у;ф;х;ц;ч;ш;щ;ъ;ы;ь;э;ю;я", ";")
    Case 6
      Temp = Source : Source = Target : Target = Temp
  End Select
  
  uS = Ubound(Source) : uT = Ubound(Target)
  If uS <> uT Then WScript.Quit ' если количество символов не совпадают, то выход
   
  Select Case Cnt
    Case 1, 2, 5, 6
      For i = 0 To uS
        Text = Replace(Text, Source(i), Target(i), 1, -1, 0)
      Next
    Case 3, 4
      For i = 0 To uS
        Text = Replace(Text, Source(i), "#" & i & "#" & i & "#", 1, -1, 0)
      Next
      For i = 0 To uS
        Text = Replace(Text, "#" & i & "#" & i & "#",Target(i), 1, -1, 0)
      Next
  End Select 
  Select Case Cnt
    Case 5, 6
      Text = Replace(Text, "́", "")' удаляется знак ударения
  End Select
  .ReplaceSel Text
  SaveEditFile
End With