' SplitText.vbs
'========================   Описание   =====================================
' Разбивка текста по заданной строке.
' Оригинальный документ не изменяется.
' Каждая найденная часть вставляется в новую вкладку (сохраняются маркеры)
'=======================   Параметры  ======================================
' 1-й параметр: строка по которой разбивается текст
'   #clip# - строка берётся из буфера обмена
'   #select# - строка берётся из выделения
'=========================    Пример    ====================================
' -"Разбить текст в новые вкладки по заданной строке ''METKA''" Call("Scripts::Main", 1, "SplitText.vbs", `"METKA"`)
' -"Разбить текст в новые вкладки по заданной строке из буфера обмена" Call("Scripts::Main", 1, "SplitText.vbs", `#clip#`)
' -"Разбить текст в новые вкладки по выделенной строке" Call("Scripts::Main", 1, "SplitText.vbs", `#select#`)

' используется Functions.vbs, который следует положить в ...AkelFiles\Plugs\Scripts\Include\

' Автор:           Аверин Андрей
' Версия:          1.0 (04.01.2015)
' Mail:            Averin-And@yandex.ru
' Site:            http://tc-image.3dn.ru/forum/9-973-11939-16-1420320454
'===========================================================================
With WScript Cnt = .Arguments.Count
  If Cnt > 0 Then Search = .Arguments(0)
End With
With AkelPad .Include("Functions.vbs") : Text = .GetSelText
  Select Case Search
    Case "#clip#" Search = .GetClipboardText : Text = ""
    Case "#select#" Search = Text : Text = ""
  End Select
  If Len(Search) = 0 Then WScript.Quit

  If Len(Text) = 0 Then Text = .GetTextRange(0, -1)
  If Len(Text) = 0 Then Wscript.Quit
  aT = SplitText(Text, Search)
  If IsArray(aT) Then
    sMarker = GetListMarkers
    For i = 0 To Ubound(aT)
      CreateNewTab : .ReplaceSel aT(i)
      WScript.Sleep 10 : SetListMarkers(sMarker)
    Next
  End If
End With